/*

######################################################
###        simple LS algorithms for the SMWC       ###
######################################################

      Version: 1.0
      File:    global.c
      Author:  Thomas Stuetzle
      Purpose: implementation of constructive and perturbative local search routines
      Check:   README and gpl.txt
      Remark:  the code is very basic and slow (no speed-ups are implemented)
      Copyright (C) 2004  Thomas Stuetzle
*/

#include <stdio.h>
#include <string.h>
#include "global.h"

/* Global Variables concerning the algorithm */

long int number_jobs;                /* number of jobs in instance */
long int deadline;                   /* deadline for jobs; not used here */

long int max_no_tries;               /* max no of runs */
long int cycle;

long int local_search_flag;    /* = 0: no local search
				  = 1; transpose
			          = 2: exchange
			          = 3: insert
			          = 4: exchange followed by insert
			          = 5: insert followed by exchange
			          = 6: transpose followed by exchange and insert 
			          = 7: transpose followed by insert and exchange 
			       */


long int constructive_flag;    /* = 0: random
				  = 1; canonical (1, 2, .. n)
				  = 2: WSPT heuristic
			       */

char        name_buf[100];           /* buffer for inputfilename */

FILE    *input;

