/*

######################################################
###        simple LS algorithms for the SMWC       ###
######################################################

      Version: 1.0
      File:    global.h
      Author:  Thomas Stuetzle
      Purpose: implementation of constructive and perturbative local search routines
      Check:   README and gpl.txt
      Remark:  the code is very basic and slow (no speed-ups are implemented)
      Copyright (C) 2004  Thomas Stuetzle
*/

#define VERBOSE(x)

#define MAX(x,y)        ((x)>=(y)?(x):(y))

#define TRUE 1
#define FALSE 0

/* constants */

#define LINE_BUF_LEN      1000

#define MAX_JOBS 501     /* max number of jobs */

/* global variables */

extern long int  number_jobs;       /* number of jobs in instance */
extern long int  deadline;          /* deadline for jobs; not used here */

extern long int  max_no_tries;      /* max no of runs */

extern long int  local_search_flag; /* = 0: no local search
				       = 1; transpose
			               = 2: exchange
				       = 3: insert
				       = 4: exchange followed by insert
				       = 5: insert followed by exchange
				       = 6: transpose followed by exchange and insert 
				       = 7: transpose followed by insert and exchange 
				    */

extern long int  constructive_flag; /* = 0: random
				       = 1; canonical (1, 2, .. n)
			               = 2: WSPT heuristic
				    */

extern char      name_buf[100];             /* buffer for inputfilename */

extern FILE      *input;











