/*

######################################################
###        simple LS algorithms for the SMWC       ###
######################################################

      Version: 1.0
      File:    ls.h
      Author:  Thomas Stuetzle
      Purpose: implementation of constructive and perturbative local search routines
      Check:   README and gpl.txt
      Remark:  the code is very basic and slow (no speed-ups are implemented)
      Copyright (C) 2004  Thomas Stuetzle
*/

#include <limits.h>
#include "global.h"

extern long int proc_time[MAX_JOBS];
extern long int weight[MAX_JOBS];
extern long int release_date[MAX_JOBS];

typedef struct {
  long int  job_at_pos[MAX_JOBS];          /* Gives the job at a certain pos */
  long int  pos_of_job[MAX_JOBS];          /* Gives the position of a specific job */ 
  long int  completion_time_job[MAX_JOBS]; /* Gives C_j of job j */
  long int  start_time_job[MAX_JOBS];      /* Gives start time of job j */
  long int  completion_time_pos[MAX_JOBS]; /* Gives C_pi(j) of job at position j */
  long int  value;                         /* Objective function value */
  } seq_struct;

extern seq_struct sequence;

void     print_sequence( );
void     print_completion_times( );

void     construct_sequence_random( );
void     construct_sequence_canonical( );
void     construct_sequence_WSPT( );
long int compute_obj_function( );
void     check_solution_consisteny_with_release_dates( );
void	 generate_random_vector();

void    local_search( );
void    ls_transpose_first( );
void    ls_exchange_first( );
void    ls_insert_first( );


