/*

######################################################
###        simple LS algorithms for the SMWC       ###
######################################################

      Version: 1.0
      File:    main.c
      Author:  Thomas Stuetzle
      Purpose: implementation of constructive and perturbative local search routines
      Check:   README and gpl.txt
      Remark:  the code is very basic and slow (no speed-ups are implemented)
      Copyright (C) 2004  Thomas Stuetzle
*/

#include <stdio.h>
#include <math.h>
#include <limits.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "global.h"
#include "ls.h"
#include "utilities.h"
#include "timer.h"

int main(int argc, char *argv[]) {

    int i;

    start_timers();
    seed = (long int) time(NULL); 
    init_program(argc, argv);

    for ( i = 1 ; i <= max_no_tries ; i++ ) {

	switch ( constructive_flag ) {
	    case 0:
		construct_sequence_random( );
		break;
	    
	    case 1:
		construct_sequence_canonical( );
		break;

	    case 2: 
		construct_sequence_WSPT( );
		break;
	}

	printf("%ld",sequence.value);
	local_search( );
	printf(" -> %ld time %.2f\n",sequence.value,elapsed_time( VIRTUAL ));

    }

    return(0);

}




