
/* This file has been generated with opag 0.7.2.  */

#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <limits.h>
#include <stdlib.h>


#include "global.h"

#ifndef STR_ERR_UNKNOWN_LONG_OPT
# define STR_ERR_UNKNOWN_LONG_OPT   "%s: unrecognized option `--%s'\n"
#endif

#ifndef STR_ERR_LONG_OPT_AMBIGUOUS
# define STR_ERR_LONG_OPT_AMBIGUOUS "%s: option `--%s' is ambiguous\n"
#endif

#ifndef STR_ERR_MISSING_ARG_LONG
# define STR_ERR_MISSING_ARG_LONG   "%s: option `--%s' requires an argument\n"
#endif

#ifndef STR_ERR_UNEXPEC_ARG_LONG
# define STR_ERR_UNEXPEC_ARG_LONG   "%s: option `--%s' doesn't allow an argument\n"
#endif

#ifndef STR_ERR_UNKNOWN_SHORT_OPT
# define STR_ERR_UNKNOWN_SHORT_OPT  "%s: unrecognized option `-%c'\n"
#endif

#ifndef STR_ERR_MISSING_ARG_SHORT
# define STR_ERR_MISSING_ARG_SHORT  "%s: option `-%c' requires an argument\n"
#endif

#define STR_HELP_TRIES "\
  -r, --tries           # number of independent trials\n"

#define STR_HELP_INPUTFILE "\
  -i, --inputfile       f inputfile (SMWC format necessary)\n"

#define STR_HELP_LOCALSEARCH "\
  -l, --localsearch     0: no ls 1: transpose 2: exchange  3: insert  4:\n\
                          exchange-insert  5: insert-exchange  6:\n\
                          transpose-exchange-insert  7:\n\
                          transpose-insert-exchange \n"

#define STR_HELP_CONSTRUCTION "\
  -c, --construction    0: random starts  1: canonical (1, 2, .. n)  3: WSPT\n\
                          heuristic\n"

#define STR_HELP_HELP "\
  -h, --help             display this help text and exit\n"

#define STR_HELP "\
  -r, --tries           # number of independent trials\n\
  -i, --inputfile       f inputfile (SMWC format necessary)\n\
  -l, --localsearch     0: no ls 1: transpose 2: exchange  3: insert  4:\n\
                          exchange-insert  5: insert-exchange  6:\n\
                          transpose-exchange-insert  7:\n\
                          transpose-insert-exchange \n\
  -c, --construction    0: random starts  1: canonical (1, 2, .. n)  3: WSPT\n\
                          heuristic\n\
  -h, --help             display this help text and exit\n"

struct options {

/* Set to 1 if option --tries (-r) has been specified.  */
unsigned int opt_tries : 1;

/* Set to 1 if option --inputfile (-i) has been specified.  */
unsigned int opt_inputfile : 1;

/* Set to 1 if option --localsearch (-l) has been specified.  */
unsigned int opt_localsearch : 1;

/* Set to 1 if option --construction (-c) has been specified.  */
unsigned int opt_construction : 1;

/* Set to 1 if option --help (-h) has been specified.  */
unsigned int opt_help : 1;

/* Argument to option --tries (-r).  */
const char *arg_tries;

/* Argument to option --inputfile (-i).  */
const char *arg_inputfile;

/* Argument to option --localsearch (-l).  */
const char *arg_localsearch;

/* Argument to option --construction (-c).  */
const char *arg_construction;

};

/* Parse command line options.  Return index of first non-option argument,
   or -1 if an error is encountered.  */
int parse_options (struct options *const options, const char *const program_name, const int argc, char **const argv)
{
  static const char *const optstr__tries = "tries";
  static const char *const optstr__inputfile = "inputfile";
  static const char *const optstr__localsearch = "localsearch";
  static const char *const optstr__construction = "construction";
  static const char *const optstr__help = "help";
  int i = 0;
  options->opt_tries = 0;
  options->opt_inputfile = 0;
  options->opt_localsearch = 0;
  options->opt_construction = 0;
  options->opt_help = 0;
  options->arg_tries = 0;
  options->arg_inputfile = 0;
  options->arg_localsearch = 0;
  options->arg_construction = 0;
  while (++i < argc)
  {
    const char *option = argv [i];
    if (*option != '-')
      return i;
    else if (*++option == '\0')
      return i;
    else if (*option == '-')
    {
      const char *argument;
      size_t option_len;
      ++option;
      if ((argument = strchr (option, '=')) == option)
        goto error_unknown_long_opt;
      else if (argument == 0)
        option_len = strlen (option);
      else
        option_len = argument++ - option;
      switch (*option)
      {
       case '\0':
        return i + 1;
       case 'c':
        if (strncmp (option + 1, optstr__construction + 1, option_len - 1) == 0)
        {
          if (argument != 0)
            options->arg_construction = argument;
          else if (++i < argc)
            options->arg_construction = argv [i];
          else
          {
            option = optstr__construction;
            goto error_missing_arg_long;
          }
          options->opt_construction = 1;
          break;
        }
        goto error_unknown_long_opt;
       case 'h':
        if (strncmp (option + 1, optstr__help + 1, option_len - 1) == 0)
        {
          if (argument != 0)
          {
            option = optstr__help;
            goto error_unexpec_arg_long;
          }
          options->opt_help = 1;
          return i + 1;
        }
        goto error_unknown_long_opt;
       case 'i':
        if (strncmp (option + 1, optstr__inputfile + 1, option_len - 1) == 0)
        {
          if (argument != 0)
            options->arg_inputfile = argument;
          else if (++i < argc)
            options->arg_inputfile = argv [i];
          else
          {
            option = optstr__inputfile;
            goto error_missing_arg_long;
          }
          options->opt_inputfile = 1;
          break;
        }
        goto error_unknown_long_opt;
       case 'l':
        if (strncmp (option + 1, optstr__localsearch + 1, option_len - 1) == 0)
        {
          if (argument != 0)
            options->arg_localsearch = argument;
          else if (++i < argc)
            options->arg_localsearch = argv [i];
          else
          {
            option = optstr__localsearch;
            goto error_missing_arg_long;
          }
          options->opt_localsearch = 1;
          break;
        }
        goto error_unknown_long_opt;
       case 't':
        if (strncmp (option + 1, optstr__tries + 1, option_len - 1) == 0)
        {
          if (argument != 0)
            options->arg_tries = argument;
          else if (++i < argc)
            options->arg_tries = argv [i];
          else
          {
            option = optstr__tries;
            goto error_missing_arg_long;
          }
          options->opt_tries = 1;
          break;
        }
       default:
       error_unknown_long_opt:
        fprintf (stderr, STR_ERR_UNKNOWN_LONG_OPT, program_name, option);
        return -1;
       error_missing_arg_long:
        fprintf (stderr, STR_ERR_MISSING_ARG_LONG, program_name, option);
        return -1;
       error_unexpec_arg_long:
        fprintf (stderr, STR_ERR_UNEXPEC_ARG_LONG, program_name, option);
        return -1;
      }
    }
    else
      do
      {
        switch (*option)
        {
         case 'c':
          if (option [1] != '\0')
            options->arg_construction = option + 1;
          else if (++i < argc)
            options->arg_construction = argv [i];
          else
            goto error_missing_arg_short;
          option = "\0";
          options->opt_construction = 1;
          break;
         case 'h':
          options->opt_help = 1;
          return i + 1;
         case 'i':
          if (option [1] != '\0')
            options->arg_inputfile = option + 1;
          else if (++i < argc)
            options->arg_inputfile = argv [i];
          else
            goto error_missing_arg_short;
          option = "\0";
          options->opt_inputfile = 1;
          break;
         case 'l':
          if (option [1] != '\0')
            options->arg_localsearch = option + 1;
          else if (++i < argc)
            options->arg_localsearch = argv [i];
          else
            goto error_missing_arg_short;
          option = "\0";
          options->opt_localsearch = 1;
          break;
         case 'r':
          if (option [1] != '\0')
            options->arg_tries = option + 1;
          else if (++i < argc)
            options->arg_tries = argv [i];
          else
            goto error_missing_arg_short;
          option = "\0";
          options->opt_tries = 1;
          break;
         default:
          fprintf (stderr, STR_ERR_UNKNOWN_SHORT_OPT, program_name, *option);
          return -1;
         error_missing_arg_short:
          fprintf (stderr, STR_ERR_MISSING_ARG_SHORT, program_name, *option);
          return -1;
        }
      } while (*++option != '\0');
  }
  return i;
}

void check_out_of_range ( double value, double MIN, double MAX, char *optionName )
/* check whether parameter values are within allowed range */
{
  if ((value<MIN)||(value>MAX)){
    fprintf(stderr,"Error: Option `%s' out of range\n",optionName);
    exit(1);
  }
}


int parse_commandline (int argc, char *argv [])
{
    int i;
    const char *progname;
    struct options options;

    progname = argv [0] != NULL && *(argv [0]) != '\0'
        ? argv [0]
        : "smwc";

    i = parse_options (&options, progname, argc, argv);

    if (i < 1)
    {
        fprintf (stderr, "No options are specified\n");
        fprintf (stderr, "Try `%s --help' for more information.\n",
                 progname);
        exit(1);
    }

    if (options.opt_help)
    {
        printf ("Usage: %s [OPTION]... [ARGUMENT]...\n\n"
                "Options:\n" STR_HELP, progname);
        exit(0);
    }

/*      puts ("\t OPTIONS:"); */


    if ( options.opt_tries ) {
        max_no_tries = atol(options.arg_tries);
/*          fputs ("  -r  --tries ", stdout); */
/*          if (options.arg_tries != NULL) */
/*              printf ("with argument \"%ld\"\n", max_no_tries); */
        check_out_of_range( max_no_tries, 1, 10000, "max_tries (tries)");
    } else {
        max_no_tries = 1;
/*          fprintf(stderr,"\tNote: number or trials is set to default 10\n"); */
    }


    if ( options.opt_inputfile )
    {
        strncpy( name_buf, options.arg_inputfile, strlen( options.arg_inputfile ) );
/*        fputs ("  -i  --inputfile ", stdout);
        if (options.arg_inputfile != NULL)
            printf ("with argument \"%s\"\n", name_buf );
*/
    }


    if ( options.opt_localsearch ) {
        local_search_flag = atol(options.arg_localsearch);
/*        fputs ("  -l  --localsearch ", stdout);
        if (options.arg_localsearch != NULL)
            printf ("with argument \"%ld\"\n", local_search_flag);
*/      
	check_out_of_range( local_search_flag, 0, LONG_MAX, "local_search_flag");
    } else {
        local_search_flag = 3;
/*          fprintf(stderr,"\tNote: local search flag is set to default 3 (insert)\n"); */
    }


    if ( options.opt_construction ) {
        constructive_flag = atol(options.arg_construction);
/*        fputs ("  -c  --construction ", stdout);
        if (options.arg_construction != NULL)
            printf ("with argument \"%ld\"\n", constructive_flag);
*/
        check_out_of_range( constructive_flag, 0, 2, "constructive_flag");
    } else {
        constructive_flag = 2;
/*          fprintf(stderr,"\tNote: constructive search flag is set to default 2 (WSPT)\n"); */
    }


/*      puts ("Non-option arguments:"); */

    while (i < argc)
        printf ("  \"%s\"\n", argv [i++]);

    return 0;
}



