
#include <stdio.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "global.h"
#include "timer.h"


static struct rusage res;
static struct timeval tp;
static double virtual_time, real_time;


void start_timers() {

    getrusage( RUSAGE_SELF, &res );
    virtual_time = (double) res.ru_utime.tv_sec +
	(double) res.ru_stime.tv_sec +
	(double) res.ru_utime.tv_usec / 1000000.0 +
	(double) res.ru_stime.tv_usec / 1000000.0;

    gettimeofday( &tp, NULL );
    real_time =    (double) tp.tv_sec +
	(double) tp.tv_usec / 1000000.0;
}

double elapsed_time( TIMER_TYPE type ) {
    if (type == REALX) {
        gettimeofday( &tp, NULL );
        return( (double) tp.tv_sec +
		(double) tp.tv_usec / 1000000.0
		- real_time );
    }
    else {
        getrusage( RUSAGE_SELF, &res );
        return( (double) res.ru_utime.tv_sec +
		(double) res.ru_stime.tv_sec +
		(double) res.ru_utime.tv_usec / 1000000.0 +
		(double) res.ru_stime.tv_usec / 1000000.0
		- virtual_time );
    }
}

