/*

######################################################
###        simple LS algorithms for the SMWC       ###
######################################################

      Version: 1.0
      File:    utilities.h
      Author:  Thomas Stuetzle
      Purpose: implementation of constructive and perturbative local search routines
      Check:   README and gpl.txt
      Remark:  the code is very basic and slow (no speed-ups are implemented)
      Copyright (C) 2004  Thomas Stuetzle
*/

/* constants for a pseudo-random number generator, taken from
   Numerical Recipes in C book */

#define IA 16807
#define IM 2147483647
#define AM (1.0/IM)
#define IQ 127773
#define IR 2836

extern long int seed; /* seed for the random number generator */

void init_program(int argc, char *argv[]);

void swap2(float v[], long int c[], long int i, long int j);

void sort2(float v[], long int c[], long int left, long int right);

double ran01( long *idum );

void read_problem_size(FILE *input);

void read_deadline(FILE *input);

void read_instance(FILE *input);

void open_input_file(char input_file_name[100]);
